function varargout = one_over_f(varargin)

% Type
%   one_over_f
% to run a GUI window.
% 
% Press "Load image" button to open the image file.
% Supported formats are BMP, GIF, JPEG and PNG file.
% When an image is read, the necessary region is calculated and shown at another window.
% The necessary region is 2^m ~2^m pixels. m is the greatest integer and computed on each images.
% The luminance image of the region and 2-dimensional Fourier transformed amplitude spectrum is presented.
% The averaged amplitude spectrum is shown on log-log coordinate.
% It is calculated in every frequency average of 2-dimensional Fourier transformed image.
% Alpha is the slope of the amplitude spectrum and displayed at bottom left on the graph.
% Alpha of the natural image equals -1.
% 
% Press "Generate" button to generate the manipulated image.
% The new image is achieved by multiplying the original spectrum by a factor of f^-n, where n is equal to the value in text box.
% The value is allowed from -2.0 to 0.0.
% Move the slider or type the new value to change the value in text box.
% When the "Generate" button is pressed, The manipulated image, 2-dimensional amplitude spectrum and the averaged amplitude spectrum are shown.
% 
% Press "Save manipulated image" button to save the manipulated image.

% Last Modified by GUIDE v2.5 22-Feb-2008 12:54:56

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @one_over_f_OpeningFcn, ...
                   'gui_OutputFcn',  @one_over_f_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before one_over_f is made visible.
function one_over_f_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to one_over_f (see VARARGIN)

% Choose default command line output for one_over_f
handles.output = hObject;

handles.sw=0;
handles.fs=0;
% Update handles structure
guidata(hObject, handles);

% UIWAIT makes one_over_f wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = one_over_f_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in Loadbutton.
function Loadbutton_Callback(hObject, eventdata, handles)
% hObject    handle to Loadbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[inputfilename, inputpathname, filterindex] = uigetfile( ...
    {'*.bmp','Windows Bitmap (*.bmp)';...
    '*.gif','Graphics Interchange Format (*.gif)';...
    '*.jpg;*.jpeg','Joint Photographic Experts Group (*.jpg,*.jpeg)';...
    '*.png','Portable Network Graphics (*.png)'}, ...
    'Pick an image');

if (filterindex==0)
%     errordlg('Select image file.','File Error');
    return
else
    imagedata = imread([inputpathname inputfilename]);
    if handles.sw>0
        figure(handles.h)
        close(handles.h)
    end
    handles.h=figure('Name','Original image','NumberTitle','off');
    imshow(imagedata);
    hold on;
    s_original = size(imagedata);
    s_trim = min(pow2(fix(log2(s_original(1:2)))));
    trimming_data = imagedata(fix(s_original(1)/2)-s_trim/2+1:fix(s_original(1)/2)+s_trim/2,fix(s_original(2)/2)-s_trim/2+1:fix(s_original(2)/2)+s_trim/2,:);
    x = [fix(s_original(2)/2)-s_trim/2+1,fix(s_original(2)/2)-s_trim/2+1,fix(s_original(2)/2)+s_trim/2,fix(s_original(2)/2)+s_trim/2,fix(s_original(2)/2)-s_trim/2+1];
    y = [fix(s_original(1)/2)-s_trim/2+1,fix(s_original(1)/2)+s_trim/2,fix(s_original(1)/2)+s_trim/2,fix(s_original(1)/2)-s_trim/2+1,fix(s_original(1)/2)-s_trim/2+1];
    xb = [-1 -1 1 1 -1];
    yb = [-1 1 1 -1 -1];
    plot(x-xb,y-yb,'k-');
    plot(x,y,'r-');
    plot(x+xb,y+yb,'w-');
    if handles.sw>0
        figure(handles.h_input)
        close(handles.h_input)
    end
    scrsz = get(0,'ScreenSize');
    handles.h_input=figure('Name','Input image','NumberTitle','off','Position',[scrsz(3)/8+1 scrsz(4)*4/7+1 scrsz(3)*3/4 scrsz(4)*2/7]);
%     imshow(trimming_data);
    if length(size(imagedata))==2
        gray_data = double(trimming_data);
    else
        gray_data = double(rgb2gray(trimming_data));
    end
    gray_data = gray_data-min(gray_data(:));
    handles.gray_data = uint8(gray_data/max(gray_data(:))*255);
    subplot(1,3,1)
    imshow(handles.gray_data);
    subplot(1,3,2)
    fdata=abs(fftshift(fft2(double(handles.gray_data))));
    mesh(fdata(s_trim/2-s_trim/4+1:2:s_trim/2+s_trim/4,s_trim/2-s_trim/4+1:2:s_trim/2+s_trim/4));
    set(gca,'XTickLabel',[],'YTickLabel',[],'ZTickLabel',[]);
    axis([0 s_trim/4 0 s_trim/4 0 max(fdata(:))])
    xlabel('u','FontSize',12','FontName','Helvetica')
    ylabel('v','FontSize',12','FontName','Helvetica')
    zlabel('Amplitude','FontSize',12','FontName','Helvetica')
    
    subplot(1,3,3)
    handles.p = one_over_f_graph(handles.gray_data);
    
    handles.sw=1;
    handles.s_trim=s_trim;
    guidata(hObject,handles);
end



% --- Executes on button press in Savebutton.
function Savebutton_Callback(hObject, eventdata, handles)
% hObject    handle to Savebutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if handles.sw==2
    [savefilename, savepathname, filterindex] = uiputfile( ...
        {'*.bmp','Windows Bitmap (*.bmp)';...
        '*.gif','Graphics Interchange Format (*.gif)';...
        '*.jpg;*.jpeg','Joint Photographic Experts Group (*.jpg,*.jpeg)';...
        '*.png','Portable Network Graphics (*.png)'}, ...
        'Save as');
    if filterindex==0
        return
    else
        imwrite(uint8(handles.m_data),[savepathname savefilename]);
    end
end


% --- Executes on button press in Manipulatebutton.
function Manipulatebutton_Callback(hObject, eventdata, handles)
% hObject    handle to Manipulatebutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if handles.sw>0
    s=str2double(get(handles.alpha,'String'));
    warnstr='Please enter the correct value.';
    warnstr(2,1:16)='min:-2.0 max:0.0';
    if s<-2.0
        s=-2.0;
        h=warndlg(warnstr,'warning');
    elseif s>0.0
        s=0.0;
        h=warndlg(warnstr,'warning');
    end
    [x y]=meshgrid(linspace(-1,1,handles.s_trim));
    r=sqrt(x.^2+y.^2);
    q=r.^(-(-s+handles.p));
    fftdata=fft2(double(handles.gray_data));
    fftabs=abs(fftdata);
    fftang=angle(fftdata);
    m=ifftshift(q);
    newfftabs=fftabs.*m;
    m_data=real(ifft2(newfftabs.*exp(sqrt(-1)*fftang)));
    m_data=m_data-min(m_data(:));
    handles.m_data=uint8(m_data/max(m_data(:))*255);
    if handles.fs==1
        figure(handles.h_manipulated)
        close(handles.h_manipulated)
    end
    s_trim=handles.s_trim;
    scrsz = get(0,'ScreenSize');
    handles.h_manipulated=figure('Name','Manipulated image','NumberTitle','off','Position',[scrsz(3)/8+1 scrsz(4)*1/7+1 scrsz(3)*3/4 scrsz(4)*2/7]);
    subplot(1,3,1)
    imshow(handles.m_data);
    subplot(1,3,2)
    fdata=abs(fftshift(fft2(double(handles.m_data))));
    mesh(fdata(s_trim/2-s_trim/4+1:2:s_trim/2+s_trim/4,s_trim/2-s_trim/4+1:2:s_trim/2+s_trim/4));
%     colormap('default');
    set(gca,'XTickLabel',[],'YTickLabel',[],'ZTickLabel',[]);
    axis([0 s_trim/4 0 s_trim/4 0 max(fdata(:))])
    xlabel('u','FontSize',12','FontName','Helvetica')
    ylabel('v','FontSize',12','FontName','Helvetica')
    zlabel('Amplitude','FontSize',12','FontName','Helvetica')
    
    subplot(1,3,3)
    one_over_f_graph(handles.m_data);
    
    handles.sw=2;
    handles.fs=1;
    guidata(hObject,handles);
end


% --- Executes on slider movement.
function s_alpha_Callback(hObject, eventdata, handles)
% hObject    handle to s_alpha (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
NewVal = sprintf('%2.2f',get(hObject, 'Value'));
set(handles.alpha,'String',NewVal);
% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider


% --- Executes during object creation, after setting all properties.
function s_alpha_CreateFcn(hObject, eventdata, handles)
% hObject    handle to s_alpha (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end



function alpha_Callback(hObject, eventdata, handles)
% hObject    handle to alpha (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of alpha as text
%        str2double(get(hObject,'String')) returns contents of alpha as a double


% --- Executes during object creation, after setting all properties.
function alpha_CreateFcn(hObject, eventdata, handles)
% hObject    handle to alpha (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --------------------------------------------------------------------
function file_menu_Callback(hObject, eventdata, handles)
% hObject    handle to file_menu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function menu_file_open_Callback(hObject, eventdata, handles)
% hObject    handle to menu_file_open (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
Loadbutton_Callback(hObject, eventdata, handles);


% --------------------------------------------------------------------
function menu_file_save_Callback(hObject, eventdata, handles)
% hObject    handle to menu_file_save (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
Savebutton_Callback(hObject, eventdata, handles);


% --------------------------------------------------------------------
function file_menu_exit_Callback(hObject, eventdata, handles)
% hObject    handle to file_menu_exit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Get the current position of the GUI from the handles structure
% to pass to the modal dialog.
close all


