function p = one_over_f_graph(idata)

% usage:
% alpha = one_over_f_graph(imagedata)
% 
% alpha : slope of amplitude spectrum
% imagedata : gray image data (2-dimensional matrix)

hold off;
[f s]=eo_polaraverage(abs(fft2(double(idata))));
f2=log2(f);
s2=log2(s);
logf=f2(1):abs(f2(end)/length(f2)):f2(end);
logs=interp1(f2,s2,logf);
h=plot(logf,logs,'b','linewidth',3);
hold on;
xlabel('log f','FontSize',12,'FontName','Helvetica');
ylabel('log Amplitude','FontSize',12','FontName','Helvetica');
p_temp=polyfit(logf,logs,1);
plot(f2,p_temp(1)*f2+p_temp(2),'r','linewidth',3);
legend('image data','linear fitting');
set(gca,'FontSize',12,'FontName','Helvetica');
p=p_temp(1);
alpha=sprintf('alpha=%2.2f',p);
text(logf(round(0.1*length(logf))),logs(round(0.8*length(logs))),alpha,'FontSize',12,'FontName','Helvetica');
axis equal